#pragma once
#include "icodec.h"
#include "dshow.h"
#include "initguid.h" // zur Vermeidung des LNK2001-Errors

//GUIDs der einzelnen Filter:
DEFINE_GUID(CLSID_WaveParser,
   0xD51BD5A1, 0x7548, 0x11CF, 0xA5, 0x20, 0x00, 0x80, 0xC7, 0x7E, 0xF5, 0x8A);
DEFINE_GUID(CLSID_MP3Encoder,
	0x5F5AFF4A, 0x2F7F, 0x4279, 0x88, 0xC2, 0xCD, 0x88, 0xEB, 0x39, 0xD1, 0x44);
DEFINE_GUID(CLSID_FileWriter,
    0x781C76F5, 0x5F6B, 0x4F84, 0xA9, 0x87, 0xFE, 0x60, 0x63, 0x31, 0x39, 0x25);

#define SAFE_RELEASE(x) { if (x) { x->Release(); x = NULL; } }

class CDshow :
	public ICodec
{
public:
	IGraphBuilder* m_pGraphBuilder;
	IMediaControl* m_pMediaControl;
	IMediaEventEx* m_pMediaEventEx;
	
	CDshow();
	HRESULT AddFilterByCLSID(
    IGraphBuilder *pGraph,          // Pointer to the Filter Graph Manager.
    const GUID& clsid,              // CLSID of the filter to create.
    IBaseFilter **ppF,              // Receives a pointer to the filter.
    LPCWSTR wszName					// A name for the filter (can be NULL).
    );
	long Open(wchar_t* pcDstFileName, wchar_t* pcSrcFileName,
		      HWND hwndEvent, UINT msg);
	int Convert();
	void Close();
	void HandleEvent(BOOL* bEnd);
};
