#include "audioeffectx.h"

// Enumerierung zur Indizierung der Einstellparameter

enum
{
	// Global
	kNumPrograms = 16,

	// Parameters Tags
	kDelayLeft = 0,
	kDelayRight,
	kFeedBackLeft,
	kFeedBackRight,

	kNumParams
};

class Delay;

//------------------------------------------------------------------------
class DelayProgram
{
friend class Delay;
public:
	DelayProgram ();
	~DelayProgram () {}

private:	
	float fDelayLeft;
	float fDelayRight;
	float fFeedBackLeft;
	float fFeedBackRight;
	char name[24];
};

//------------------------------------------------------------------------
class Delay : public AudioEffectX
{
public:
	Delay (audioMasterCallback audioMaster);
	~Delay ();

	//---from AudioEffect-----------------------
	virtual void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames);

	virtual void setProgram (VstInt32 program);
	virtual void setProgramName (char* name);
	virtual void getProgramName (char* name);
	virtual bool getProgramNameIndexed (VstInt32 category, VstInt32 index, char* text);
	
	virtual void setParameter (VstInt32 index, float value);
	virtual float getParameter (VstInt32 index);
	virtual void getParameterLabel (VstInt32 index, char* label);
	virtual void getParameterDisplay (VstInt32 index, char* text);
	virtual void getParameterName (VstInt32 index, char* text);

	virtual void resume ();

	virtual bool getEffectName (char* name);
	virtual bool getVendorString (char* text);
	virtual bool getProductString (char* text);
	virtual VstInt32 getVendorVersion () { return 1000; }
	
	virtual VstPlugCategory getPlugCategory () { return kPlugCategEffect; }

protected:
	void setDelayLeft (float delay);
	void setDelayRight (float delay);
	DelayProgram* programs;
			
	float* bufferLeft;		//Puffer
	float* bufferRight;

	float fDelayLeft;		// Verzgerung in Samples, der von der UI bergeben wird
	float fDelayRight;
	float fFeedBackLeft;	// Feedback
	float fFeedBackRight;
	
	
	long delayLeft;		// Wert fr die Indizierung der Pufferelemente
	long delayRight;	// 
	long sizeLeft;		// Puffergre
	long sizeRight;
	long cursorLeft;	// Cursorposition
	long cursorRight;
};


