#include "audioeffectx.h"

enum
{
	// Parameters Tags
	kLowLevel,
	kLowFrequency,
	kMid1Level,
	kMid1Frequency,
	kMid1Q,
	kMid2Level,
	kMid2Frequency,
	kMid2Q,
	kHighLevel,
	kHighFrequency,
	kNumParams = 10
};

typedef struct
{
	float a0;
	float a1;
	float a2;
	float b1;
	float b2;
	// Schieberegister fr Filter:
	float x[3];
	float y[3];	
}FILTERPARAMETER;

//------------------------------------------------------------------------
class FourBandEq : public AudioEffectX
{
public:
	FourBandEq (audioMasterCallback audioMaster);
	~FourBandEq ();

	//---from AudioEffect-----------------------
	virtual void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames);
	virtual void setProgramName (char* name);
	virtual void getProgramName (char* name);
	
	virtual void setParameter (VstInt32 index, float value);
	virtual float getParameter (VstInt32 index);
	virtual void getParameterLabel (VstInt32 index, char* label);
	virtual void getParameterDisplay (VstInt32 index, char* text);
	virtual void getParameterName (VstInt32 index, char* text);
	virtual bool getEffectName (char* name);
	virtual bool getVendorString (char* text);
	virtual bool getProductString (char* text);
	virtual VstInt32 getVendorVersion () { return 1000; }
	
	virtual VstPlugCategory getPlugCategory () { return kPlugCategEffect; }
protected:
	char programName[kVstMaxProgNameLen + 1];
	//eingestellte Parameter
	float fLowLevel;
	float fLowFrequency;
	float fMid1Level;
	float fMid1Frequency;
	float fMid1Q;
	float fMid2Level;
	float fMid2Frequency;
	float fMid2Q;
	float fHighLevel;
	float fHighFrequency;
	
	FILTERPARAMETER fpParam[4];

	void SetLowPassParameters(FILTERPARAMETER* fp, float level, float f);
	void SetBandPassParameters(FILTERPARAMETER* fp, float level, float f, float Q);
	void SetHighPassParameters(FILTERPARAMETER* fp, float level, float f);	
	float ParamToLevel(float param);
	float LevelToParam(float level);
	float ParamToFreq(float param);
	float FreqToParam(float frequency);
	float ParamToQ(float param);
	float QToParam(float Q);

};


