package synth;
/**
 * ADSRData-Objekte enthalten die Parameter zur Generierung von ADSR-Hllkurven. Eine ADSR-Hllkurve
 * besteht aus den vier Phasen Attack Time (Anstiegzeit), Decay Time (Abfallzeit), Sustain Time (Haltezeit) und 
 * Release Time (Freigabezeit). Die Abkrzung gibt die Anfangsbuchstaben der einzelnen Phasen an.Anstelle der 
 * Sustain Time wird auch gelegentlich der Begriff Hold Time verwendet. Die hierfr verwendete Abkrzung ist ADHR und 
 * kann synonym zu ADSR verwendet werden. *
 * @author Michael Steppat *
 */

public class ADSRData {
	/**
	 * Anstiegzeit (Attack Time)
	 */
	public double T1;
	/**
	 * Abfallzeit (Decay Time)
	 */
	public double T2;
	/**
	 * Haltezeit (Sustain Time, Hold Time)
	 */
	public double T3;
	/**
	 * Release Time (Freigabezeit)
	 */
	public double T4;
	/**
	 * Pegel zum Ende des Anstiegs
	 */
	public double L1;
	/**
	 * Pegel zum Ende des Abfalls
	 */
	public double L2;
	/**
	 * Pegel zum Ende der Haltephae
	 */
	public double L3;
}
